# coding: utf-8

"""
    Faxsuite RESTful API

    <p><img src=\"https://service.fax-api.de/4.0/img/fax-api.png\" height=\"100\" title=\"title\" /></p>  # API Definition <p><img src=\"https://service.fax-api.de/4.0/img/open_api.png\" height=\"50\" title=\"title\" /></p>  Die <b>RESTful API</b> basiert auf den <b>OpenAPI v3.0.3</b> Spezifikationen. OpenAPI Spezifikationen (OAS) definieren eine standardisierte und programmiersprachenunabhängige Schnittstellenbeschreibung für RESTful APIs. Diese Schnittstelle ist nutzbar ohne dass der Zugang zum Quellcode, zusätzliche Dokumentation oder die Untersuchung des Netzwerk-Traffics erforderlich ist. Somit kann ein Nutzer den Dienst mit einem Minimum an Implementierungslogik verstehen, mit ihm interagieren und einfach und schnell als API-Schnittstelle in seine eigene Softwareanwendung integrieren..<br><br>Weitere Informationen zu OpenAPI finden sie hier: <a href=\"https://www.openapis.org/\"><b>https://www.openapis.org/</b></a>   # Einleitung  <p><img src=\"https://service.fax-api.de/4.0/img/fax-api-faxsuite_v2.png\" height=\"350\" title=\"title\" />  </p>  Mit unserer <b>Faxsuite</b> können Sie überall und zu jederzeit Faxe senden und empfangen. Neben vielen anderen Funktionalitäten bietet Ihnen unsere <b>Faxsuite</b> auch eine RESTFul API-Schnittstelle. Damit können Sie z. B. aus Ihrer eigenen Softwareanwendung Faxe automatisiert versenden. Zeitintensive und teure Investionen in Hardware und Software gehören der Vergangenheit an und sind nicht mehr notwendig..<br><br>Um den API Service nutzen zu können, müssen Sie sich für die <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a> anmelden. Ein kostenloser Testzugang kann <a href=\"https://www.faxverteiler.com/testzugang/\"><b>hier</b></a> beantragt werden. (<i>To use the API service you need to sign up for the <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a>. A free trial access can be requested <a href=\"https://www.faxverteiler.com/testzugang/\"><b>here</b></a></i>).<br><br>Mit der <b>Faxsuite</b> haben Sie die Kontrolle über Ihre Fax-Kampangen. Mit dem kostenlosen Testzugang können Sie alle Faxsuite Module (Fax-API, Mail2Fax, Faxdrucker, Faxmailing und Faxempfang) unverbindlich ausprobieren. Sie bekommen 10 kostenlose Faxseiten, die Sie zum aktiven Kennenlernen unserer Faxsuite nutzen können. (<i>You can test the <b>Faxsuite</b> modules for four weeks without obligation. You will receive 10 free fax pages with the free trial access</i>)<br><br>Nachdem Sie den Zugang beantragt haben, können Sie sich <a href=\"https://www.faxsuite.de/\"><b>hier</b></a> in die <b>Faxsuite</b> einloggen. Unter dem Menüpunkt 'FAX-API | Konto verwalten' können Sie ein neues Fax-API Konto erstellen. Bei der Erstellung des Fax-API Kontos wird automatisch ein Autorisierungs-Schlüssel generiert, welchen Sie für den Zugang zur API-Schnittstelle benötigen. (<i>After creating a login you can access the <b>Faxsuite</b> <a href=\"https://www.faxsuite.de/\"><b>here</b></a>. In the menu 'FAX-API | Konto verwalten' you can create a new API-Account and receive the related token/key you need to gain access to our API service</i>).<br><br>Die standardisierte API Dokumentation wird Ihnen in zwei unterschiedlichen, als nicht <b>interaktive</b> und <b>interaktive</b> Varinaten angeboten:  |Name|Type|Link| |-----|-----|-------| | <b>Redoc</b> | non interactive | <b><a href=\"https://service.fax-api.de/4.0/rest/index.html\">click here for redoc</a></b> | <b>Swagger UI</b> | interactive (self hosted) | <b><a href=\"https://service.fax-api.de/4.0/rest/swagger-ui/index.html\">click here for swagger</a></b> |    # noqa: E501

    OpenAPI spec version: 4.0.0
    Contact: support@fax-api.de
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Job(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'account': 'str',
        'status': 'str',
        'error_code': 'int',
        'options': 'JobOptions',
        'info': 'JobInfo',
        'statistics': 'JobStatistics'
    }

    attribute_map = {
        'id': 'id',
        'account': 'account',
        'status': 'status',
        'error_code': 'errorCode',
        'options': 'options',
        'info': 'info',
        'statistics': 'statistics'
    }

    def __init__(self, id=None, account=None, status=None, error_code=None, options=None, info=None, statistics=None):  # noqa: E501
        """Job - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._account = None
        self._status = None
        self._error_code = None
        self._options = None
        self._info = None
        self._statistics = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if account is not None:
            self.account = account
        if status is not None:
            self.status = status
        if error_code is not None:
            self.error_code = error_code
        if options is not None:
            self.options = options
        if info is not None:
            self.info = info
        if statistics is not None:
            self.statistics = statistics

    @property
    def id(self):
        """Gets the id of this Job.  # noqa: E501

        Describes the identification number (UUID) of a fax job  # noqa: E501

        :return: The id of this Job.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Job.

        Describes the identification number (UUID) of a fax job  # noqa: E501

        :param id: The id of this Job.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def account(self):
        """Gets the account of this Job.  # noqa: E501

        Describes the account the job does belongs to  # noqa: E501

        :return: The account of this Job.  # noqa: E501
        :rtype: str
        """
        return self._account

    @account.setter
    def account(self, account):
        """Sets the account of this Job.

        Describes the account the job does belongs to  # noqa: E501

        :param account: The account of this Job.  # noqa: E501
        :type: str
        """

        self._account = account

    @property
    def status(self):
        """Gets the status of this Job.  # noqa: E501

        Describes the current state of the fax job  # noqa: E501

        :return: The status of this Job.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this Job.

        Describes the current state of the fax job  # noqa: E501

        :param status: The status of this Job.  # noqa: E501
        :type: str
        """
        allowed_values = ["scheduling", "scheduled", "processing", "halted", "locked", "canceled", "finished", "error"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def error_code(self):
        """Gets the error_code of this Job.  # noqa: E501

        If status is equal to 'error' this field contains the error code number  # noqa: E501

        :return: The error_code of this Job.  # noqa: E501
        :rtype: int
        """
        return self._error_code

    @error_code.setter
    def error_code(self, error_code):
        """Sets the error_code of this Job.

        If status is equal to 'error' this field contains the error code number  # noqa: E501

        :param error_code: The error_code of this Job.  # noqa: E501
        :type: int
        """

        self._error_code = error_code

    @property
    def options(self):
        """Gets the options of this Job.  # noqa: E501


        :return: The options of this Job.  # noqa: E501
        :rtype: JobOptions
        """
        return self._options

    @options.setter
    def options(self, options):
        """Sets the options of this Job.


        :param options: The options of this Job.  # noqa: E501
        :type: JobOptions
        """

        self._options = options

    @property
    def info(self):
        """Gets the info of this Job.  # noqa: E501


        :return: The info of this Job.  # noqa: E501
        :rtype: JobInfo
        """
        return self._info

    @info.setter
    def info(self, info):
        """Sets the info of this Job.


        :param info: The info of this Job.  # noqa: E501
        :type: JobInfo
        """

        self._info = info

    @property
    def statistics(self):
        """Gets the statistics of this Job.  # noqa: E501


        :return: The statistics of this Job.  # noqa: E501
        :rtype: JobStatistics
        """
        return self._statistics

    @statistics.setter
    def statistics(self, statistics):
        """Sets the statistics of this Job.


        :param statistics: The statistics of this Job.  # noqa: E501
        :type: JobStatistics
        """

        self._statistics = statistics

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Job, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Job):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
